/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: RCSL 1.0/RPSL 1.0 
 *  
 * Portions Copyright (c) 1995-2002 RealNetworks, Inc. All Rights Reserved. 
 *      
 * The contents of this file, and the files included with this file, are 
 * subject to the current version of the RealNetworks Public Source License 
 * Version 1.0 (the "RPSL") available at 
 * http://www.helixcommunity.org/content/rpsl unless you have licensed 
 * the file under the RealNetworks Community Source License Version 1.0 
 * (the "RCSL") available at http://www.helixcommunity.org/content/rcsl, 
 * in which case the RCSL will apply. You may also obtain the license terms 
 * directly from RealNetworks.  You may not use this file except in 
 * compliance with the RPSL or, if you have a valid RCSL with RealNetworks 
 * applicable to this file, the RCSL.  Please see the applicable RPSL or 
 * RCSL for the rights, obligations and limitations governing use of the 
 * contents of the file.  
 *  
 * This file is part of the Helix DNA Technology. RealNetworks is the 
 * developer of the Original Code and owns the copyrights in the portions 
 * it created. 
 *  
 * This file, and the files included with this file, is distributed and made 
 * available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER 
 * EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS ALL SUCH WARRANTIES, 
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS 
 * FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. 
 * 
 * Technology Compatibility Kit Test Suite(s) Location: 
 *    http://www.helixcommunity.org/content/tck 
 * 
 * Contributor(s): 
 *  
 * ***** END LICENSE BLOCK ***** */ 

#ifndef _HXDATE_H
#define _HXDATE_H

#include "hxtypes.h"
#include "hlxclib/time.h"

#define HX_YEAR_OFFSET 1900

typedef struct system_time
{
    UINT16 second;		// 0-59
    UINT16 minute;		// 0-59
    UINT16 hour;		// 0-23
    UINT16 dayofweek;		// 0-6  (Sunday = 0)
    UINT16 dayofmonth;		// 1-31
    UINT16 dayofyear;		// 1-366 (January 1 = 1)
    UINT16 month;		// 1-12 (January = 1)
    UINT16 year;		// year - 1900 or (year - HX_YEAR_OFFSET)
    INT16 gmtDelta;		// Greenwich Mean Time Delta in +/- hours
} HX_DATETIME;

// datetime points to a structure that is allocated to receive the date and time

HX_DATETIME HX_GET_DATETIME(void);


int	MonthNo (char * month);  
time_t	ParseDate(char *date_string);

#endif //_HXDATE_H
